/******************************************************************************
 *                                                                            *
 * Copyright 1997 Advanced Micro Devices, Inc.                                *
 *                                                                            *
 * This software is the property of Advanced Micro Devices, Inc  (AMD)  which *
 * specifically  grants the user the right to modify, use and distribute this *
 * software provided this notice is not removed or altered.  All other rights *
 * are reserved by AMD.                                                       *
 *                                                                            *
 * AMD MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, WITH REGARD TO THIS *
 * SOFTWARE.  IN NO EVENT SHALL AMD BE LIABLE FOR INCIDENTAL OR CONSEQUENTIAL *
 * DAMAGES IN CONNECTION WITH OR ARISING FROM THE FURNISHING, PERFORMANCE, OR *
 * USE OF THIS SOFTWARE.                                                      *
 *                                                                            *
 * So that all may benefit from your experience, please report  any  problems *
 * or suggestions about this software back to AMD.  Please include your name, *
 * company,  telephone number,  AMD product requiring support and question or *
 * problem encountered.                                                       *
 *                                                                            *
 * Advanced Micro Devices, Inc.       Worldwide support and contact           *
 * Logic Products Division            information available at:               *
 * Systems Engineering                                                        *
 * 5204 E. Ben White Blvd.     http://www.amd.com/html/support/techsup.html   *
 * Austin, TX 78741                                                           *
 *****************************************************************************/


#ifndef _AMDRIVE_H_
#define _AMDRIVE_H_


// Values for the PCN driver

#define PCN_MAX			1	// Total number of active drivers 
#define PCN_MAX_RX_SIZE		1536
#define PCN_MAX_TX_SIZE		1536
#ifdef SMALLSRAM
#define PCN_MAX_RX		2
#define PCN_MAX_TX		2
#else
#define PCN_MAX_RX		4
#define PCN_MAX_TX		16
#endif


// Error return codes.

// Error values 
typedef enum {
	AMERROR_OK,
	AMERROR_FRAME,
	AMERROR_NOT_FOUND,
	AMERROR_INVALID_UNIT,
	AMERROR_NO_DEVICE,
	AMERROR_NO_IO,
	AMERROR_CONST,
	AMERROR_TOO_BIG,
	AMERROR_INVALID_FRAME,
	AMERROR_FULL
} AMERROR;


// Debug functions 

#if 1
#define DEBUG1(a) Nprintf a
#define DEBUG2(a) Nprintf a
#define DEBUG3(a) Nprintf a
#define DEBUG4(a) 
#define DEBUG5(a)
#define DEBUG_LEVEL  3
#else
#define DEBUG1(a)
#define DEBUG2(a)
#define DEBUG3(a)
#define DEBUG4(a)
#define DEBUG5(a)
#define DEBUG_LEVEL 0
#endif

// this macro converts an pointer of type seg:offset
// into a 20 bit physical address

#define FTP(fptr,lptr) lptr = (((unsigned long)((char _far *) fptr) & 0xffff0000)>>12)+((unsigned long)((char _far *) fptr) & 0xffff)

// Standard types

typedef volatile unsigned int VU16;
typedef volatile unsigned char VU8;
typedef unsigned long U32;
typedef unsigned int U16;
typedef unsigned char U8;

#endif

