#include <stdio.h>
#include <conio.h>

#include "am186cc.h"

#include "stdincs.h"
#include "pnpappn.h"

#define ISA_IO	0x0200
#define ADD_PROM 	(ISA_IO)
#define MC1		(ISA_IO + 0x0002)
#define RDP 	    (ISA_IO + 0x0010)
#define RAP		(ISA_IO + 0x0012)
#define RESET		(ISA_IO + 0x0014)
#define IDP		(ISA_IO + 0x0016)

int     ip_ecr_w(int, WORD);
int     ip_ecr_r(int);

loop_back(void)
{
int x=0;
	
	/* possibly put this stuff in a loop */
	
//	_outpw(PACS, 0x77);   	/* set up chip select with 3 wait states */
//	_outpw(MPCS, 0x8183);	/* set chip select block size to 128k and 3 wait states */

//	_outpw(PIOMODE0, 0xe3);	/* set PIOs 7,6,5,1,0 to unterminated inputs */
//	_outpw(PIODIR0, 0xe3);  /*   "   */
		
//    _inpw(ISA_IO + 0x0e);	/* read in product ID */
//    x = ip_bcr_r(8); /* read and write to BCR MSWRA register */
//    ip_bcr_w(8,x);    
//    ip_ecr_w(3, 19); /* write and read to ECR #3 mask register */
//    x = ip_ecr_r(3);
//    _inpw(RESET); /* force the device to reset */
    
    
	ip_ecr_w(15, ip_ecr_r(15) | 0x8000);	// put into Promiscous mode / accept all frames
	ip_ecr_w(15, ip_ecr_r(15) | 0x0008);	// allocate FCS to receiver
	ip_bcr_w(2, ip_bcr_r(2) | 0x4011);		// set TMAU_LOOP bit in ISACSCR2 
	ip_ecr_w(15, ip_ecr_r(15) | 0x0404);	// set MEDECL and LOOP bits in CSR15 
	ip_ecr_w(15, ip_ecr_r(15) & 0xffbf);    // make sure intl bit is cleared in CSR15 
      
	
	printf ("\nInitialized external loopback mode...\n");
 //   printf("\nSmall SRAM = %x", SMALLSRAM);
    //printf("\nMCS0 = %x", MCS0);
    /*  some garbage code to make the chip work the bus a little bit */

	return 0;
}


/****************************************************************************
 NAME
    ip_ecr_r - Ethernet Controller Registers (ECR) read.

 DESCRIPTION

    This function performs a single 16-bit read of the specified Ethernet
    Controller Register. You must specify the ECR you want access.

 INPUT
    Argument <reg> specifies the ECR you want to read.


    RDP - #define RAP Iobase+0x12
    IDP - #define RDP Iobase+0x10

 RETURN
    The data read from the specified ECR is returned to you.
    If the specified register is not a legal number, the returned value
    is 0xDEAD.

****************************************************************************/
int  ip_ecr_r(int reg)
{
    if ( reg <= 126 ) {
        _outpw(RAP, reg);              /* Write Register Address Port. */
        return( _inpw(RDP) );          /* Read BCR Data Port. */
    }
    else
        return(0xDEAD);
}

/****************************************************************************
 NAME
    ip_ecr_w -  Ethernet Controller Register (ECR) write.

 DESCRIPTION
    This function performs a single 16-bit write to the specified Ethernet
    Controller Register. You must specify the ECR you want to access and
    the data to be written.

 INPUT
    Argument <reg> specifies the ECR you want to access.
    Argument <data> specifies the data you want to write.

 OUTPUT
    The specified data is written to the specified ECR.


    RAP - #define RAP Iobase+0x12
    RDP - #define IDP Iobase+0x10

 RETURN
    0   Function successfully completed.
    1   Error, Unknown Register.

****************************************************************************/
int     ip_ecr_w(int reg, WORD data)
{
    if ( reg <= 126 ) {
        _outpw(RAP, reg);              /* Write Register Address Port. */
        _outpw(RDP, data);             /* Write BCR Data Port. */
        return(0);
    }
    else
        return(1);
}
