//==============================================================================
// FILE   : LED.H
//
// DESC   : Low level LED driver include file.
//
// TOOLS  : MSVC
//
//          $Revision: 1.1 $
//              $Date: 1997/12/01 19:11:45 $
//           $Modtime$
//            $Author: jhall $
//          $Workfile$
//           $Logfile$
//
// =============================================================================
//                                                                             
//  Copyright 1997 Advanced Micro Devices, Inc.                                
//                                                                             
//  This software is the property of Advanced Micro Devices, Inc  (AMD)  which 
//  specifically  grants the user the right to modify, use and distribute this 
//  software provided this notice is not removed or altered.  All other rights 
//  are reserved by AMD.                                                       
//                                                                             
//  AMD MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, WITH REGARD TO THIS 
//  SOFTWARE.  IN NO EVENT SHALL AMD BE LIABLE FOR INCIDENTAL OR CONSEQUENTIAL 
//  DAMAGES IN CONNECTION WITH OR ARISING FROM THE FURNISHING, PERFORMANCE, OR 
//  USE OF THIS SOFTWARE.                                                      
//                                                                             
//  So that all may benefit from your experience, please report  any  problems 
//  or suggestions about this software back to AMD.  Please include your name, 
//  company,  telephone number,  AMD product requiring support and question or 
//  problem encountered.                                                       
//                                                                             
//  Advanced Micro Devices, Inc.       Worldwide support and contact           
//  Logic Products Division            information available at:               
//  Systems Engineering                                                        
//  5204 E. Ben White Blvd.     http://www.amd.com/html/support/techsup.html   
//  Austin, TX 78741                                                           
//
// =============================================================================

#ifndef LED_H
#define LED_H

//------------------------------------------------------------------------------
// LED definitions for the Net186 board.
// Typedefs and structs
//

#define  LED1  0x01
#define  LED2  0x02
#define  LED3  0x04
#define  LED4  0x08
#define  LED5  0x10
#define  LED6  0x20
#define  LED7  0x40
#define  LED8  0x400

#define  LED_LONG_DELAY   13000
#define  LED_SHORT_DELAY  6000

#define BoardLEDShift 3
#define BoardLEDMask 0x47f

//------------------------------------------------------------------------------
// Function prototypes.
//

void ledInitialize( void );
void PostLEDs( WORD bLEDMask );
void ledBlink( BYTE bLEDMask, DWORD delay );
//BYTE InquireLEDs( void );
void LEDon(WORD bLEDMask);
void LEDoff(WORD bLEDMask);
#endif 

//==============================================================================
// ENDOF   : LED.H
//------------------------------------------------------------------------------
// HISTORY :
// $Log: LED.H $
// Revision 1.1  1997/12/01 19:11:45  jhall
// Initial revision
//
// =============================================================================
