/******************************************************************************
 *                                                                            *
 *     186LEDS.C                                                              *
 *                                                                            *
 *     This file contains hardware-dependent LED display code.                *
 *                                                                            *
 ******************************************************************************
 *                                                                            *
 * Copyright 1996 Advanced Micro Devices, Inc.                                *
 *                                                                            *
 * This software is the property of Advanced Micro Devices, Inc  (AMD)  which *
 * specifically  grants the user the right to modify, use and distribute this *
 * software provided this notice is not removed or altered.  All other rights *
 * are reserved by AMD.                                                       *
 *                                                                            *
 * AMD MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, WITH REGARD TO THIS *
 * SOFTWARE.  IN NO EVENT SHALL AMD BE LIABLE FOR INCIDENTAL OR CONSEQUENTIAL *
 * DAMAGES IN CONNECTION WITH OR ARISING FROM THE FURNISHING, PERFORMANCE, OR *
 * USE OF THIS SOFTWARE.                                                      *
 *                                                                            *
 * So that all may benefit from your experience, please report  any  problems *
 * or suggestions about this software back to AMD.  Please include your name, *
 * company,  telephone number,  AMD product requiring support and question or *
 * problem encountered.                                                       *
 *                                                                            *
 * Advanced Micro Devices, Inc.       Worldwide support and contact           *
 * Logic Products Division            information available at:               *
 * Systems Engineering                                                        *
 * 5204 E. Ben White Blvd.     http://www.amd.com/html/support/techsup.html   *
 * Austin, TX 78741                                                           *
 *****************************************************************************/

//#include "emon.h"
#include <conio.h>

#include "stdincs.h"
#include "am186cc.h"

#define TIP_LEDS		   0x0305
#define TIP_LEDS_H         0305h 
#define TIP_HEX			   0x0306

#define TIP_LCDC		   0x030C
#define TIP_LCDS		   0x030D
#define TIP_LCDD		   0x030E


#define TIP_LEDS_TIMER	   0x80
#define TIP_LEDS_SPORT	   0x40

#define SEG7

#define _inp( a) inp( a )
#define _inpw( a ) inpw( a )

#define _outp( a , b) outp( a , b)
#define _outpw( a , b ) outpw( a , b)


//#define IS186CC ((_inpw(PRL) & 0xf000)==0x4000)

//#define IS_TIP_ATTACHED ((_inpw( RESCON ) & 0x0080))


STATIC WORD BoardLEDMask;
STATIC WORD BoardLEDShift;
STATIC WORD LEDtoggle = 0;

void PrintLCD( char * string )
{
	int i;
	for(i=0;i<1000;i++);
	_outp(TIP_LCDC, 1);
	for(i=0;i<1000;i++);
	while(*string)
	{
		for(i=0;i<1000;i++);
//		while(_inp(TIP_LCDS)&0x80);
		_outp(TIP_LCDD, *string++);
	}

//	while(_inp(TIP_LCDS)&0x80);
		
}
///////////////////////////////////////////////////////////////////////////
//    PostLEDs() -- light the LEDs with the supplied values
//
void PostLEDs( WORD bLEDMask )
{

    int temp;
#if defined(SEG7)
		_outp(TIP_HEX, bLEDMask&0xff);
	
	temp = _inpw(MPCS);
	_outp(MPCS,temp|MPCS_IOSIZ);			// set to 8 bit I/O Bus
	_outp(TIP_HEX+1, bLEDMask>>8);      	// output the high byte to the second led segments
	_outp(TIP_LEDS, bLEDMask&0xff);      	// output the high byte to the second led segments
	_outp(MPCS,temp);						// set back to 16 bit I/O Bus
	_outpw(MPCS,temp);						// set back to 16 bit I/O Bus
#endif
#if defined(LED)
	
	temp = _inpw(MPCS);
	_outp(MPCS,temp|MPCS_IOSIZ);			// set to 8 bit I/O Bus
	_outp(TIP_LEDS, bLEDMask&0xff);     	// output the high byte to the second led segments
	_outp(MPCS,temp);						// set back to 16 bit I/O Bus
	_outpw(MPCS,temp);						// set back to 16 bit I/O Bus
#endif
}


///////////////////////////////////////////////////////////////////////////
//    InquireLEDs() -- Get the current LED values
//
BYTE InquireLEDs( void )
{
   return (BYTE)_inp(TIP_LEDS);
}
